 float4 vecAmbient;
float4x4 matWorldViewProj;
float4x4 matWorld;
float4x4 matWorldInv;
float4x4 matWorldView;
float2 filter2 = { 0.25,0.0 };
float2 filter3 = { 0.0,0.25 };
float2 filter4 = { 0.5, 0.0 };
float2 filter5 = { 0.0, 0.5 };
float4 vecFog;
float4 vecViewPos;
float DoFog(float4 Pos)	{ float3 P = mul(Pos,matWorldView); return saturate((vecFog.y-P.z) * vecFog.z); }
float3 vecSunPos;
float4 vecSunColor;
float4 vecSunDir;
float4 vecSunDiffuse = float4(255.f/255.f, 255.f/255.f, 255.f/255.f, 1.f);
float4 vecLight;
float4 vecLightPos[8];
float4 vecLightColor[8];
float3 vecFalloff = float3(0.f, 0.f, 1.5f);
Texture mtlSkin2;
sampler sBaseTex = sampler_state {
Texture = <mtlSkin2>;
MinFilter = Linear;
MagFilter = Linear;
MipFilter = Linear;
   AddressU  = clamp;
AddressV  = clamp;
};
struct out_terraintex3 {
float4 Pos		: POSITION;
float4 Color	: COLOR0;
float  Fog		: FOG;
float2 MaskCoord: TEXCOORD0;
float3 Sun		: TEXCOORD1;
float3 View		: TEXCOORD2;
};
out_terraintex3 vs_terraintex3(float4 inPos : POSITION,float3 inNormal : NORMAL,float3 inTangent : TEXCOORD2,float2 inTexCoord0 : TEXCOORD0) {
out_terraintex3 Out;
float3x3 worldToTangentSpace;
worldToTangentSpace[0] = mul(inTangent, matWorld);
worldToTangentSpace[1] = mul(cross(inTangent, inNormal), matWorld);
worldToTangentSpace[2] = mul(inNormal, matWorld);
Out.Pos = mul(inPos,matWorldViewProj);
 float3 N = normalize(mul(inNormal,matWorld));
float3 P = mul(inPos,matWorld);
float3 Viewer = P - vecViewPos;
Out.View = mul(worldToTangentSpace, -Viewer);
Out.Sun = mul(worldToTangentSpace, -vecSunDir);
#ifndef NORMALMAPPING
float3 objSunDir = normalize(mul(-vecSunDir.xyz, matWorldInv));
float  sunDiff   = max(dot(inNormal, objSunDir), 0);
Out.Color        = float4(vecSunColor.rgb * sunDiff, 1) + vecAmbient.rgba;
#else
Out.Color = vecAmbient.rgba;
#endif
#ifdef DYN_LIGHT
for(int i = 0;
 i <= 5;i++) {
float4 objLightPos  = mul(float4(vecLightPos[i].xyz, 1), matWorldInv);
float4 objLightDir  = objLightPos - inPos;
float4 objLightDirN = normalize(objLightDir);
float  diffLight    = max(dot(objLightDirN, inNormal), 0);
float falloffFactor = 0;
if(vecLightPos[i].w > 0) {
float linearDistance = length(objLightDir)/vecLightPos[i].w;
if(linearDistance < 1) falloffFactor = 1 - linearDistance;
}
diffLight *= falloffFactor;
Out.Color.rgb  += vecLightColor[i].rgb * diffLight;
}
#endif
Out.Fog = DoFog(inPos);
Out.MaskCoord = inTexCoord0.xy;
return Out;
}
float4 ps_terraintex3_1(out_terraintex3 In): COLOR {
float3 ViewDir = normalize(In.View);
float4 BaseColor = tex2D(sBaseTex,frac(In.MaskCoord.xy*1)/2.002);
float4 FinalColor = BaseColor;
FinalColor = (FinalColor*In.Color);
FinalColor.a = 1.0f;
return FinalColor;
}
technique terraintex3_13 {
 pass one {
sampler[0] = (sBaseTex);
alphaBlendEnable = false;
zenable=true;
zwriteenable=true;
VertexShader = compile vs_2_0 vs_terraintex3();
PixelShader = compile ps_3_0 ps_terraintex3_1();
}
}